import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private xj;
    get xk(): IAnchoredCategorySeriesInteractionManager;
    xf: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    kz(): string;
    protected cg(): SeriesView;
    o0(a: SeriesView): void;
    xo: boolean;
    constructor();
    x5: string;
    ju(a: any, b: string): any;
    get valueColumn(): IFastItemColumn$1<number>;
    set valueColumn(a: IFastItemColumn$1<number>);
    private xl;
    xx: string;
    x1: string;
    x3: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get ys(): Brush;
    set ys(a: Brush);
    static readonly ye: DependencyProperty;
    trendLineThickness: number;
    yu: PenLineCap;
    yt: DoubleCollection;
    trendLinePeriod: number;
    xs: number;
    fo(a: any): boolean;
    protected xc(a: number, b: number, c: Axis): any[];
    protected o8(a: any, b: string, c: any, d: any): void;
    aq(a: Axis): AxisRange;
    protected no(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected wm(): number;
    xr(a: CategorySeriesView): number;
    yb(a: PointCollection, b: number, c: CategorySeriesView): void;
    xd(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    xe(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    protected fn(): boolean;
    protected g0(): List$1<SeriesLayerPropertyOverlay>;
    private x7;
    gl(a: Rect, b: Rect, c: SeriesView): boolean;
    nj(a: boolean, b: SeriesView): void;
    w2(a: CategoryFrame, b: CategorySeriesView): void;
    w5(a: CategoryFrame, b: CategorySeriesView): void;
    xg: CategoryFrame;
    po(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    x8(a: CategoryFrame, b: CategorySeriesView): void;
    protected qd(): void;
    jy(a: any, b: Point): any;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get trendlinePreparer(): IPreparesCategoryTrendline;
    protected xv: string;
    protected xu: string;
    abstract x9(a: Axis): void;
    abstract ya(a: Axis): void;
    protected n1(a: any): void;
    xh: CategorySeriesMarkerCollisionAvoidance;
    jr(a: Point): any;
    xi: ConsolidatedItemHitTestBehavior;
    get mayContainUnknowns(): boolean;
    h2(): number;
    protected get_xt(): number;
    protected get xt(): number;
    ar(a: Rect): AxisRange;
    private yd;
    private xn;
    private xp;
    xq: number;
    private yc;
    ic(a: ValueLayerValueMode, b: Axis): number;
    am(a: ValueLayerValueMode): number[];
    tk(a: ValueLayerValueMode): Point;
    tl(a: number[]): Point;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c3: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private c4;
    get c5(): ITrendLineManager;
    set c5(a: ITrendLineManager);
    get c6(): boolean;
    da(): void;
    c8(): void;
    c7(): void;
    cv(): CategoryBucketCalculator;
    c9(): void;
    db(): void;
    dc(a: number): Rect;
    protected a7(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
